#!/usr/bin/python3
"""Upotreba ./validate.py test/*.in*"""

import string

def check(lines):
    nl = []   # ispravno formatirane linije
    E = "\n"  # line ending
    if lines[0][-1] == "\r\n":
        E = "\r\n"

    n = int(lines[0])
    assert 1 <= n <= 50, "n je kriv"
    nl.append("{}{}".format(n, E))

    for l in lines[1:n+1]:
        x = int(l)
        assert 1 <= x <= 500, "Ti kriv"
        nl.append("{}{}".format(x, E))
    
    
    k = int(lines[n + 1])
    assert 1 <= k <= 200, "k je kriv"
    nl.append("{}{}".format(k, E))

    assert len(lines) == n+k+2, "Krivi broj linija"
    
    ovaj = 0

    for l in lines[n+2:n+k+2]:
        x = int(l)
        if x != 0:
          ovaj = 1
        assert 0 <= x < n, "Xi kriv"
        nl.append("{}{}".format(x, E))

    assert lines == nl, "Krivi format (%s vs %s)" % (lines, nl)
    assert lines[-1][-1] == "\n", "Zadnji red ne zavrsava sa \\n"
    return {'n': n, 'k' : k, 'x' : ovaj}

# Ocekivani clusteri! Ovo vjerojatno zelis promijeniti!
expected_clusters = {'Normalni': 10}

def what_cluster(data):
    return 'Normalni'

################### Zadatak-specifican kod iznad ove linije #########################

import sys
import glob
import hashlib


def group_in_batches(files):
    # mnozenje.in.1a, mnozenje.in.1b sprema u isti batch

    files.sort()
    B = []
    for f in files:
        if f[-1].islower() and len(B) > 0 and f[:-1] == B[-1][-1][:-1]:
            B[-1].append(f)
        else:
            B.append([f])
    return B


if __name__ == "__main__":
    f = []
    for pattern in sys.argv[1:]:
        for filename in glob.glob(pattern):
            f.append(filename)

    bc = []
    for batch in group_in_batches(f):
        if 'dummy' not in batch[0]:
            bc.append([])
        for filename in batch:
            print("{}: ".format(filename), end="")
            try:
                lines = open(filename).readlines()
                summary = check(lines)
                c = what_cluster(summary)
                if 'dummy' not in batch[0]:
                    bc[-1].append(c)
            except Exception as e:
                print("Greska!", e)
                raise
            else:
                print("Sve ok! (cluster {}, summary = {})".format(c, summary))

    clusters = {}
    for b in bc:
        for c in b:
            assert c == b[0], "Ima razlicitih cluster-a unutar batcha"
        if not b[0] in clusters:
            clusters[b[0]] = 0
        clusters[b[0]] += 1

    assert clusters == expected_clusters, "Kriva raspodjela clustera ({} vs {})".format(clusters, expected_clusters)

    # Buda test - provjeri duplikate
    hashes = set(hashlib.sha1(open(x, 'rb').read()).hexdigest() for x in f)
    assert len(hashes) == len(f), "Ima duplikata!"
